/*  ǥ ׽Ʈ α׷.  */
#include "hre.h"
#include <fcntl.h>
#include <stdio.h>
#include <sys/stat.h>
#include <unistd.h>

#define SUCCESS_EXIT_CODE 1
#define FATAL_EXIT_CODE (44 | 0x10000000)

extern int time_report;

void 
usage (void)
{
  fprintf (stderr, " : ./hre_test -i ǥ -o ׽Ʈ_ڿ\n");
  fprintf (stderr, "ɼ \n");
  fprintf (stderr, "\t-h : \n");
  fprintf (stderr, "\t-i ǥ : ׽Ʈϰ ϴ  ǥ\n");
  fprintf (stderr, "\t-o ڿ : ǥĿ ´ ڿ\n");
  fprintf (stderr, "\t-g ȣ   :   ǥİ ڿ  ׽Ʈ ڵ带  \n");
  fprintf (stderr, "\t             in[ȣ], str[ȣ], out[ȣ]  ȴ.\n");
  fprintf (stderr, "1) ./hre_test -i \"abc[a-z]\" -o \"abcdd\"\n");
  fprintf (stderr, "2) ./hre_test -i \"abc[a-z]\" -o \"abcdd\" -g 100\n");
  exit (1);
}

void
make_test_example_files (fname, context)
     char *fname, *context;
{
  int fd, n;

    /*   */
  if ((fd = open (fname, O_CREAT|O_RDWR)) == -1)
    perror("open error : ");
  if ((n = write(fd, context, strlen (context))) != strlen (context))
    perror("write error : ");
  close (fd);

  if(chmod(fname, S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH) < 0)
    {
        perror("chmod error :");
        exit(0);
    }
}

/* ׽Ʈ  Ѵ.  */
void
make_test_example (num, re, str, pos)
     int num, pos;
     char *re, *str;
{
  char in_name[256], out_name[256], str_name[256];
  char posbuf[256];
  int fd, n;

  sprintf (in_name, "in%d", num);
  sprintf (out_name, "out%d", num);
  sprintf (str_name, "str%d", num);
  sprintf (posbuf, "%d", pos);

  /*    θ .  */
  if (!access (in_name, F_OK) || !access (out_name, F_OK) || !access (str_name, F_OK))
    {
      fprintf (stderr, "׽Ʈ ȣ %d  ϵ մϴ.\n", num);
      exit (0);
    }

  make_test_example_files (in_name, re);
  make_test_example_files (out_name, posbuf);
  make_test_example_files (str_name, str);

  fprintf (stderr, "׽Ʈ  %d   Ǿϴ.\n", num);
}

/*  ǥ ̺귯 phony main Լ.  */
int
main (argc, argv)
     int argc;
     char *argv[];
{
  int i, opt, num = -1;
  char *re=NULL, *str=NULL;
  hre_t test;
  hre_option_t option;

  while((opt = getopt(argc, argv, "hg:i:o:")) != -1) 
    {
      switch(opt) 
        {
	case 'h':
	  usage ();
	  break;
	case 'g':
	  num = atoi (optarg);
	  break;
	case 'i':
	  re = optarg;
	  break;
	case 'o':
	  str = optarg;
	  break;
	default:
	  usage ();
	  break;
	}
    }

  time_report = 1;

  if (re == NULL || str == NULL)
    usage ();

  fprintf (stderr, "Է ǥ : %s\n", re);
  fprintf (stderr, "Է ڿ : %s\n", str);

  /* ڰ Է Խ Ѵ.  */
  test = hre_compile (re, option);

  /* ã.  ȯ -1  ƴ   ã ̸, ȯ ã 
      Ű ִ.  */
  i = hre_search (test, str);
  if (i == -1)
    {
      fprintf (stderr, "ϰ ´ ڿ ã Ͽϴ.\n");
      printf ("%d\n", i);
      /*    ΰ?  */
      if (num != -1)
	make_test_example (num, re, str, i);

      return (FATAL_EXIT_CODE);
    }

  /* ޸  */
  hre_free (test);

  printf ("%d\n", i);

  /*    ΰ?  */
  if (num != -1)
    make_test_example (num, re, str, i);
  
  return (SUCCESS_EXIT_CODE);
}
